package io.dekorate.jaeger.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class CollectorBuilder extends CollectorFluentImpl<CollectorBuilder> implements VisitableBuilder<io.dekorate.jaeger.config.Collector,CollectorBuilder>{

    CollectorFluent<?> fluent;
    Boolean validationEnabled;

    public CollectorBuilder(){
            this(true);
    }
    public CollectorBuilder(Boolean validationEnabled){
            this(new Collector(), validationEnabled);
    }
    public CollectorBuilder(CollectorFluent<?> fluent){
            this(fluent, true);
    }
    public CollectorBuilder(CollectorFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new Collector(), validationEnabled);
    }
    public CollectorBuilder(CollectorFluent<?> fluent,io.dekorate.jaeger.config.Collector instance){
            this(fluent, instance, true);
    }
    public CollectorBuilder(CollectorFluent<?> fluent,io.dekorate.jaeger.config.Collector instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withHost(instance.getHost()); 
            fluent.withName(instance.getName()); 
            fluent.withNamespace(instance.getNamespace()); 
            fluent.withPort(instance.getPort()); 
            this.validationEnabled = validationEnabled; 
    }
    public CollectorBuilder(io.dekorate.jaeger.config.Collector instance){
            this(instance,true);
    }
    public CollectorBuilder(io.dekorate.jaeger.config.Collector instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withHost(instance.getHost()); 
            this.withName(instance.getName()); 
            this.withNamespace(instance.getNamespace()); 
            this.withPort(instance.getPort()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableCollector build(){
            EditableCollector buildable = new EditableCollector(fluent.getHost(),fluent.getName(),fluent.getNamespace(),fluent.getPort());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            CollectorBuilder that = (CollectorBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
