package io.dekorate.jaeger.config;

import java.lang.StringBuffer;
import java.lang.StringBuilder;
import io.dekorate.deps.kubernetes.api.builder.BaseFluent;
import java.lang.Object;
import java.lang.String;
import java.lang.Boolean;

public class CollectorFluentImpl<A extends CollectorFluent<A>> extends io.dekorate.deps.kubernetes.api.builder.BaseFluent<A> implements CollectorFluent<A>{

    private String host = "";
    private String name = "jaeger-collector";
    private String namespace = "";
    private int port = 14267;

    public CollectorFluentImpl(){
    }
    public CollectorFluentImpl(io.dekorate.jaeger.config.Collector instance){
            this.withHost(instance.getHost()); 
            this.withName(instance.getName()); 
            this.withNamespace(instance.getNamespace()); 
            this.withPort(instance.getPort()); 
    }

    public String getHost(){
            return this.host;
    }

    public A withHost(String host){
            this.host=host; return (A) this;
    }

    public Boolean hasHost(){
            return this.host != null;
    }

    public A withNewHost(String arg1){
            return (A)withHost(new String(arg1));
    }

    public A withNewHost(StringBuilder arg1){
            return (A)withHost(new String(arg1));
    }

    public A withNewHost(StringBuffer arg1){
            return (A)withHost(new String(arg1));
    }

    public String getName(){
            return this.name;
    }

    public A withName(String name){
            this.name=name; return (A) this;
    }

    public Boolean hasName(){
            return this.name != null;
    }

    public A withNewName(String arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuilder arg1){
            return (A)withName(new String(arg1));
    }

    public A withNewName(StringBuffer arg1){
            return (A)withName(new String(arg1));
    }

    public String getNamespace(){
            return this.namespace;
    }

    public A withNamespace(String namespace){
            this.namespace=namespace; return (A) this;
    }

    public Boolean hasNamespace(){
            return this.namespace != null;
    }

    public A withNewNamespace(String arg1){
            return (A)withNamespace(new String(arg1));
    }

    public A withNewNamespace(StringBuilder arg1){
            return (A)withNamespace(new String(arg1));
    }

    public A withNewNamespace(StringBuffer arg1){
            return (A)withNamespace(new String(arg1));
    }

    public int getPort(){
            return this.port;
    }

    public A withPort(int port){
            this.port=port; return (A) this;
    }

    public Boolean hasPort(){
            return true;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            CollectorFluentImpl that = (CollectorFluentImpl) o;
            if (host != null ? !host.equals(that.host) :that.host != null) return false;
            if (name != null ? !name.equals(that.name) :that.name != null) return false;
            if (namespace != null ? !namespace.equals(that.namespace) :that.namespace != null) return false;
            if (port != that.port) return false;
            return true;
    }




}
