package io.dekorate.jaeger.config;

import io.dekorate.project.Project;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import io.dekorate.kubernetes.config.Port;
import java.lang.Object;
import java.lang.String;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class JaegerAgentConfig extends Configuration{

    private boolean operatorEnabled = false;
    private String version = "1.10";
    private io.dekorate.jaeger.config.Collector collector = null;
    private io.dekorate.kubernetes.config.Port[] ports = new io.dekorate.kubernetes.config.Port[0];

    public JaegerAgentConfig(){
    }
    public JaegerAgentConfig(Project project,Map<ConfigKey,Object> attributes,boolean operatorEnabled,String version,io.dekorate.jaeger.config.Collector collector,io.dekorate.kubernetes.config.Port[] ports){
            super(project, attributes);
            this.operatorEnabled = operatorEnabled;
            this.version = version != null ? version : "1.10";
            this.collector = collector != null ? collector : null;
            this.ports = ports != null ? ports : new io.dekorate.kubernetes.config.Port[0];
    }

    public boolean isOperatorEnabled(){
            return this.operatorEnabled;
    }

    public String getVersion(){
            return this.version;
    }

    public io.dekorate.jaeger.config.Collector getCollector(){
            return this.collector;
    }

    public io.dekorate.kubernetes.config.Port[] getPorts(){
            return this.ports;
    }

    public static JaegerAgentConfigBuilder newJaegerAgentConfigBuilder(){
            return new io.dekorate.jaeger.config.JaegerAgentConfigBuilder();
    }




}
