package io.dekorate.jaeger.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;

public class JaegerAgentConfigBuilder extends JaegerAgentConfigFluentImpl<JaegerAgentConfigBuilder> implements VisitableBuilder<JaegerAgentConfig,JaegerAgentConfigBuilder>{

    JaegerAgentConfigFluent<?> fluent;
    Boolean validationEnabled;

    public JaegerAgentConfigBuilder(){
            this(true);
    }
    public JaegerAgentConfigBuilder(Boolean validationEnabled){
            this(new JaegerAgentConfig(), validationEnabled);
    }
    public JaegerAgentConfigBuilder(JaegerAgentConfigFluent<?> fluent){
            this(fluent, true);
    }
    public JaegerAgentConfigBuilder(JaegerAgentConfigFluent<?> fluent,Boolean validationEnabled){
            this(fluent, new JaegerAgentConfig(), validationEnabled);
    }
    public JaegerAgentConfigBuilder(JaegerAgentConfigFluent<?> fluent,JaegerAgentConfig instance){
            this(fluent, instance, true);
    }
    public JaegerAgentConfigBuilder(JaegerAgentConfigFluent<?> fluent,JaegerAgentConfig instance,Boolean validationEnabled){
            this.fluent = fluent; 
            fluent.withProject(instance.getProject()); 
            fluent.withAttributes(instance.getAttributes()); 
            fluent.withOperatorEnabled(instance.isOperatorEnabled()); 
            fluent.withVersion(instance.getVersion()); 
            fluent.withCollector(instance.getCollector()); 
            fluent.withPorts(instance.getPorts()); 
            this.validationEnabled = validationEnabled; 
    }
    public JaegerAgentConfigBuilder(JaegerAgentConfig instance){
            this(instance,true);
    }
    public JaegerAgentConfigBuilder(JaegerAgentConfig instance,Boolean validationEnabled){
            this.fluent = this; 
            this.withProject(instance.getProject()); 
            this.withAttributes(instance.getAttributes()); 
            this.withOperatorEnabled(instance.isOperatorEnabled()); 
            this.withVersion(instance.getVersion()); 
            this.withCollector(instance.getCollector()); 
            this.withPorts(instance.getPorts()); 
            this.validationEnabled = validationEnabled; 
    }

    public EditableJaegerAgentConfig build(){
            EditableJaegerAgentConfig buildable = new EditableJaegerAgentConfig(fluent.getProject(),fluent.getAttributes(),fluent.isOperatorEnabled(),fluent.getVersion(),fluent.getCollector(),fluent.getPorts());
            return buildable;
    }

    public boolean equals(Object o){
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            if (!super.equals(o)) return false;
            JaegerAgentConfigBuilder that = (JaegerAgentConfigBuilder) o;
            if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

            if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
            return true;
    }




}
