package io.dekorate.jaeger.config;

import io.dekorate.deps.kubernetes.api.builder.VisitableBuilder;
import java.lang.StringBuilder;
import io.dekorate.kubernetes.config.Port;
import io.dekorate.deps.kubernetes.api.builder.Nested;
import java.util.ArrayList;
import io.dekorate.kubernetes.config.PortFluent;
import io.dekorate.kubernetes.config.ConfigurationFluent;
import java.lang.String;
import io.dekorate.deps.kubernetes.api.builder.Predicate;
import java.lang.Deprecated;
import java.util.Iterator;
import java.lang.Boolean;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.project.Project;
import java.lang.StringBuffer;
import io.dekorate.kubernetes.config.PortBuilder;
import java.util.Collection;
import java.lang.Object;
import java.util.Map;

public interface JaegerAgentConfigFluent<A extends JaegerAgentConfigFluent<A>> extends ConfigurationFluent<A>{


    public boolean isOperatorEnabled();
    public A withOperatorEnabled(boolean operatorEnabled);
    public Boolean hasOperatorEnabled();
    public String getVersion();
    public A withVersion(String version);
    public Boolean hasVersion();
    public A withNewVersion(String arg1);
    public A withNewVersion(StringBuilder arg1);
    public A withNewVersion(StringBuffer arg1);
    
/**
 * This method has been deprecated, please use method buildCollector instead.
 * @return The buildable object.
 */
@Deprecated public io.dekorate.jaeger.config.Collector getCollector();
    public io.dekorate.jaeger.config.Collector buildCollector();
    public A withCollector(io.dekorate.jaeger.config.Collector collector);
    public Boolean hasCollector();
    public A withNewCollector(String host,String name,String namespace,int port);
    public JaegerAgentConfigFluent.CollectorNested<A> withNewCollector();
    public JaegerAgentConfigFluent.CollectorNested<A> withNewCollectorLike(io.dekorate.jaeger.config.Collector item);
    public JaegerAgentConfigFluent.CollectorNested<A> editCollector();
    public JaegerAgentConfigFluent.CollectorNested<A> editOrNewCollector();
    public JaegerAgentConfigFluent.CollectorNested<A> editOrNewCollectorLike(io.dekorate.jaeger.config.Collector item);
    public A withPorts(io.dekorate.kubernetes.config.Port... ports);
    
/**
 * This method has been deprecated, please use method buildPorts instead.
 */
@Deprecated public io.dekorate.kubernetes.config.Port[] getPorts();
    public io.dekorate.kubernetes.config.Port[] buildPorts();
    public io.dekorate.kubernetes.config.Port buildPort(int index);
    public io.dekorate.kubernetes.config.Port buildFirstPort();
    public io.dekorate.kubernetes.config.Port buildLastPort();
    public io.dekorate.kubernetes.config.Port buildMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);
    public Boolean hasMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);
    public A addToPorts(int index,io.dekorate.kubernetes.config.Port item);
    public A setToPorts(int index,io.dekorate.kubernetes.config.Port item);
    public A addToPorts(io.dekorate.kubernetes.config.Port... items);
    public A addAllToConfigPorts(Collection<io.dekorate.kubernetes.config.Port> items);
    public A removeFromPorts(io.dekorate.kubernetes.config.Port... items);
    public A removeAllFromConfigPorts(Collection<io.dekorate.kubernetes.config.Port> items);
    public A removeMatchingFromConfigPorts(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);
    public Boolean hasPorts();
    public JaegerAgentConfigFluent.ConfigPortsNested<A> addNewConfigPort();
    public JaegerAgentConfigFluent.ConfigPortsNested<A> addNewPortLike(io.dekorate.kubernetes.config.Port item);
    public JaegerAgentConfigFluent.ConfigPortsNested<A> setNewPortLike(int index,io.dekorate.kubernetes.config.Port item);
    public JaegerAgentConfigFluent.ConfigPortsNested<A> editPort(int index);
    public JaegerAgentConfigFluent.ConfigPortsNested<A> editFirstPort();
    public JaegerAgentConfigFluent.ConfigPortsNested<A> editLastPort();
    public JaegerAgentConfigFluent.ConfigPortsNested<A> editMatchingPort(io.dekorate.deps.kubernetes.api.builder.Predicate<PortBuilder> predicate);

    public interface CollectorNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,CollectorFluent<JaegerAgentConfigFluent.CollectorNested<N>>{

        
    public N and();    public N endCollector();
}
    public interface ConfigPortsNested<N> extends io.dekorate.deps.kubernetes.api.builder.Nested<N>,PortFluent<JaegerAgentConfigFluent.ConfigPortsNested<N>>{

        
    public N and();    public N endConfigPort();
}


}
